import { TimelineEngine } from "./engine";
export declare class Events {
    handlers: {};
    constructor(handlers?: {});
}
export interface EventTypes {
    /**
     * 设置时间前(手动)
     * @type {{ time: number, engine: TimelineEngine }}
     * @memberof EventTypes
     */
    beforeSetTime: {
        time: number;
        engine: TimelineEngine;
    };
    /**
     * 设置时间后(手动)
     * @type {{ time: number, engine: TimelineEngine }}
     * @memberof EventTypes
     */
    afterSetTime: {
        time: number;
        engine: TimelineEngine;
    };
    /**
     * tick设置时间后
     * @type {{ time: number, engine: TimelineEngine }}
     * @memberof EventTypes
     */
    setTimeByTick: {
        time: number;
        engine: TimelineEngine;
    };
    /**
     * 设置运行速率前
     * return false 将阻止设置速率
     * @type {{ speed: number, engine: TimelineEngine }}
     * @memberof EventTypes
     */
    beforeSetPlayRate: {
        rate: number;
        engine: TimelineEngine;
    };
    /**
     * 设置运行速率后
     * @type {{ speed: number, engine: TimelineEngine }}
     * @memberof EventTypes
     */
    afterSetPlayRate: {
        rate: number;
        engine: TimelineEngine;
    };
    /**
     * 运行
     * @type {{engine: TimelineEngine}}
     * @memberof EventTypes
     */
    play: {
        engine: TimelineEngine;
    };
    /**
     * 停止
     * @type {{ engine: TimelineEngine }}
     * @memberof EventTypes
     */
    paused: {
        engine: TimelineEngine;
    };
    /**
     * 运行结束
     * @type {{ engine: TimelineEngine }}
     * @memberof EventTypes
     */
    ended: {
        engine: TimelineEngine;
    };
}
